/*
by: Vhid Najafi
mail: geo.vahid@gmail.com
www.vnplugin.com
modify this at your own risk
*/---------------------------------------------------------------

try(destroydialog vnsnow)catch()
rollout vnsnow "Snow 1.0.0"
(
	local vn_pfs
	local op1
	local op2
	local op3
	local op4
	local op5
	local op6
	local op_1
	local op_2
	local op_3
	
	pickbutton pick "Pick Object" autoDisplay:false width:190 pos:[5,5] 
	label picked_obj ".............." pos:[75,30]
	group "Parameters"
     (
	label l1 "Count:" pos:[10,70]
	spinner sp_count "" range:[1,100000,2000] type:#integer pos:[110,70] fieldwidth:60
	
	label l2 "Gravity Scale:" pos:[10,95]
	spinner sp_gravity "" range:[0,100000 ,50] pos:[110,95] fieldwidth:60
	
	label l3 "Scale:" pos:[10,120]
	spinner sp_scale "" range:[0,10000,100] pos:[110,120] fieldwidth:60
	
	label l4 "Scale Var:" pos:[10,145]
	spinner sp_scale_var "" range:[0,10000,35] pos:[110,145] fieldwidth:60
		 
	 label l6 "Turbulence:" pos:[10,170]
	 spinner sp_Turbulence "" range:[0,1000,12] type:#integer pos:[110,170] fieldwidth:60 
	 )
	 
	Button btn_pf "Open PF Source"  width:190 height:30 pos:[5,200] 

	Button selectdeflector "Select Deflector" width:190 pos:[5,230] 
	
	Button calculate "CREATE" width:190 height:30 pos:[5,260] 
	
	
	on btn_pf pressed do particleFlow.openParticleView()
	on calculate pressed do
	(
		if(isvalidnode pick.object)then
		(
		vn_pfs = PF_Source()
		vn_pfs.dir = [0,0,-1]
		vn_pfs.Quantity_Viewport = 100
		particleFlow.BeginEdit()
		--
		op1 = Birth()
        op1.Emit_Stop = 500*160
        op1.amount = sp_count.value
		--
		op2 = Position_Object()
        op2.Emitter_Objects = #( pick.object)
		--
		op3 =  Force()
		if(isvalidnode $VN_Gravity_02)then
			(
				--nothing
			)else
			(
				gravity_vn = Gravity()
				gravity_vn.dir = [0,0,-1]
				gravity_vn.name ="VN_Gravity_02"
			)
		if(isvalidnode $VN_wind_02)then
			(
				--nothing
			)else
			(
				wind_vn = wind()
				wind_vn.strength = 0.1
				wind_vn.turbulence = sp_Turbulence.value
				wind_vn.frequency = 1
				wind_vn.name ="VN_wind_02"
			)	
		op3.Force_Space_Warps = #($VN_Gravity_02 , $VN_wind_02)
		op3.Influence = sp_gravity.value
		--
		op4 = Collision_Spawn()
		if(isvalidnode $VN_Deflector_02)then
			(
				--nothing
			)else
			(
				deflector_vn = UDeflector()
				deflector_vn.name ="VN_Deflector_02"
				deflector_vn.bounce = 0.3
				deflector_vn.bouncevar = 100
                deflector_vn.chaos = 100
			)
		op4.Collision_Nodes = #($VN_Deflector_02)
		op4.Number_of_Offsprings = 1
		--
		op5 = ShapeLibrary()-- ShapeLibrary()
		op5.Scale_Value = sp_scale.value
		op5.size = 3.6
		op5.Use_Scale = on
		op5.Scale_Variation = sp_scale_var.value
		op5.Type_3D = 6
		--
		op6 = Material_Static()
		vn_water_mat = vraymtl()
		vn_water_mat.Diffuse = color 255 255 255
		op6.Assigned_Material = vn_water_mat
		--
        op7 = DisplayParticles()
        op7.color = vn_pfs.wireColor
        op7.type = 6
		op7.color = color 255 255 255
		--
		op8 = RenderParticles()
		--
		ev1 = Event()
        ev1.SetPViewLocation (vn_pfs.X_Coord) (vn_pfs.Y_Coord+100)
        particleFlow.EndEdit()
        ev1.AppendAction op1
        ev1.AppendAction op2
        ev1.AppendAction op3
		ev1.AppendAction op4
        ev1.AppendAction op5
		ev1.AppendAction op6
		ev1.AppendAction op7
		--
        
		-----------------------------------------------------------------
		particleFlow.BeginEdit()
        ev_1 = Event()
	    ev_1.setPViewLocation -56 343
		--
		op_1 =Stop()
		--
		op_2 =ShapeLibrary()
		op_2.Scale_Value = sp_scale.value
		op_2.size = 3.6
		op_2.Use_Scale = on
		op_2.Scale_Variation = sp_scale_var.value
		op_2.Type_3D = 6
		--
		op_3 = Material_Static()
		op_3.Assigned_Material = vn_water_mat
		 --
		op_4 = DisplayParticles()
        op_4.color = ev_1.wireColor
		op_4.type = 6
		op_4.color = color 255 255 255
		--
		particleFlow.EndEdit()
		
		ev_1.appendAction op_1
        ev_1.appendAction op_2
		ev_1.appendAction op_3
		ev_1.appendAction op_4
		
		-----------------------------------------------------------------
        op4.setNextActionList  op4 ev_1
		vn_pfs.AppendAction op8
        vn_pfs.AppendInitialActionList ev1
		-----------------------------------------------------------------
		--particleFlow.openParticleView()
		)else
		(
			messagebox "Select Source objects"
		)
		
	)
	
	on sp_count changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op1.amount = val
		)
		
	)

	on sp_gravity changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op3.Influence = val
		)
		
	)
	
	on sp_scale changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op5.Scale_Value = val
			op_2.Scale_Value = val
		)
		if(val < sp_scale_var.value)then
			(
				sp_scale_var.value = val
			)
	)

	on sp_scale_var changed val do
	(
		if (isvalidnode vn_pfs)then
		(
			op5.Scale_Variation = val
			op_2.Scale_Variation = val
		)
		if(val > sp_scale.value)then
			(
				sp_scale.value = val
			)
		
	)
	
	on sp_Turbulence changed val do
	(
		if (isvalidnode vn_pfs and isvalidnode $VN_wind_02)then
		(
			$VN_wind_02.turbulence = val
		)
		
	)
	
	---------------------------------------
	on pick picked obj do 
	(
		picked_obj.text = obj.name
		if (isvalidnode vn_pfs)then
		(
		 op2.Emitter_Objects = #( obj)
		)
	)
	
	on selectdeflector pressed do
	(
		if(isvalidnode $VN_Deflector_02)then select $VN_Deflector_02
		max modify mode 
	)
)
createdialog vnsnow 200 295 150 90
